-- this script creates a database 'TSEASYLABELHistory', a sql server login 'tseasylogin' with password 'TS1EASY#pass', and a user 'tseasyuser' under the new database.
-- To be able to move print jobs from one sql server 2005/2008 instance (A) to another (B), create the same login on both instances,
-- so that a linked server (A) can be created on B without creating a remote login.


if not exists (select * from sys.databases where name='TSEASYLABELHistory')
create database TSEASYLABELHistory
go

use TSEASYLABELHistory
if not exists (SELECT * FROM sys.Tables where name='Jobs')
begin
create table Jobs(JobId Int primary key identity (1,1), Name nvarchar(260),Batches int, BatchSize int,PrinterName nvarchar(32),
prtr varchar(5), prdriver varchar(5),prvendor varchar(5),portname varchar(256), QTime datetime, Status nvarchar(64),FormatFile image,TimeStamp datetime,
ELUserId nvarchar(32),WinUserName nvarchar(256),ComputerName nvarchar(32), JobDesc nvarchar(128),JobId1 int)
end

if not exists (SELECT * FROM sys.Tables where name='JobDetails')
begin
create table JobDetails(JobDetailId int primary key identity (1,1), JobId int  CONSTRAINT j REFERENCES Jobs, BatchesDone int, JobTime datetime,Status nvarchar(64))
end

if not exists (SELECT * FROM sys.Tables where name='JobLabels')
begin
create table JobLabels(LabelId int primary key identity (1,1), JobId int CONSTRAINT l REFERENCES Jobs,JobNumber int,LabelNumber int, BatchTime datetime)
end 

if not exists (SELECT * FROM sys.Tables where name='Pictures')
begin
create table Pictures(MD5 char(32) primary key, BinaryData image, MsgTime datetime, fieldvalue nvarchar(260))
end 

if not exists (SELECT * FROM sys.Tables where name='LabelFields')
begin
create table LabelFields(FieldId bigint primary key identity (1,1), LabelId int CONSTRAINT f REFERENCES JobLabels, FieldName nvarchar(32),FieldType char(1),
FieldValue nvarchar(MAX), MD5 char(32) CONSTRAINT md5 REFERENCES Pictures,MsgTime datetime,CodePage int)
end

if not exists(SELECT * FROM sys.Tables where name='userlog')
begin
create table userlog(LogId int primary key identity(1,1), CompName nvarchar(32),whodid nvarchar(32), towhom nvarchar(32)
,action tinyint,actiontime datetime, preId nvarchar(32), postId nvarchar(32), preName nvarchar(64), postName nvarchar(64)
,preDesc nvarchar(64), postDesc nvarchar(64), prePermission int, postPermission int, PasswordChanged bit)
end 

if not exists(SELECT * FROM sys.Tables where name='ReasonsForFormatChange')
begin
create table ReasonsForFormatChange(LogId int primary key identity(1,1), FormatName nvarchar(260), BackupFormat nvarchar(260), Reason nvarchar(512)
,TimeStamp datetime ,ELuserId nvarchar(32), WinUserName nvarchar(256),ComputerName nvarchar(32))
end

use TSEASYLABELHistory
if not exists(select * from master..syslogins where name='tseasylogin')
begin 
 create login tseasylogin with password='TS1EASY#pass',DEFAULT_DATABASE=TSEASYLABELHistory;
end

if not exists(select * from sys.sysusers where name='tseasyuser')
begin
 create user tseasyuser for login tseasylogin
end
go


use TSEASYLABELHistory

-- grant permissions at table level
GRANT SELECT, INSERT, UPDATE, Delete ON dbo.Jobs to tseasyuser        -- set status
GRANT SELECT, INSERT, UPDATE, Delete ON dbo.LabelFields to tseasyuser -- set md5

GRANT SELECT, INSERT, Delete ON dbo.JobDetails to tseasyuser
GRANT SELECT, INSERT, Delete ON dbo.JobLabels to tseasyuser

GRANT SELECT, INSERT ON dbo.Pictures to tseasyuser
GRANT SELECT, INSERT, Delete ON dbo.userlog to tseasyuser
GRANT SELECT, INSERT, Delete ON dbo.ReasonsForFormatChange to tseasyuser

-- to create a linked server

use master
Grant alter any linked server to tseasylogin
go






